---@type Mq
mq = require('mq')
require "MqUtils"
require "MqSpells"


local raid = false
local auto_attack = true
local auto_attack_attempts = 0
local auto_mount = true
local auto_sit = false
local debuff_target = false
local flip_mob = false
local allow_pets = true
local invis_after_fight = false
local invis_vs_undead = true
local auto_approach = true
local auto_approach_dist = 50
local use_ecliptic = false
local robe_name = 'Flameweaver Robe of the Celestial Zenith'
local charm_name = 'Phantasmal Luclinite Charm of Brilliance'
local amulet_of_mariner = 'Amulet of the Drowned Mariner'
local feather_target_min_hp = 0
local feather_target_max_my_mana = 100
local feather_item = 'Unified Phoenix Feather'
local feather_spell = 'Grace of Unity'
local horn_item = 'Miniature Horn of Unity'
local horn_spell = 'Blessing of Unity'
local pet_heal_spell = 'Renewal of Iilivina Rk. II'

local TURN_SUMMONED = 559
local FORCE_OF_ELEMENTS = 8800
local IMPROVED_TWINCAST = 515
local HEART_OF_SKYFIRE = 785
local SPIRE_OF_THE_ELEMENTS = 1370
local SERVANT_OF_RO = 174
local HOST_OF_ELEMENTS = 207
local COMPANION_RELOCATION = 3816
local FOCUS_OF_ARCANUM = 1211
local THAUMATURGE_FOCUS = 390


local battle_aa = {FORCE_OF_ELEMENTS,
					IMPROVED_TWINCAST,
					HEART_OF_SKYFIRE,
					SPIRE_OF_THE_ELEMENTS,
					FOCUS_OF_ARCANUM, 
					THAUMATURGE_FOCUS}

if allow_pets then
	if raid == false then
		table.insert(battle_aa, SERVANT_OF_RO)
	end
	table.insert(battle_aa, HOST_OF_ELEMENTS)
end
if raid then
	feather_target_min_hp = 0
end
function MageKill_2()
	mq.cmdf('/setwintitle %s', mq.TLO.Me.Name())
	LogXp()
	HealerMercReact()
	if not IsTargetValid() then
		return
	end
	local xSpawn = mq.TLO.Target
	if xSpawn.LineOfSight() == false then
		print(xSpawn.Name() .. ' is not LineOfSight.')
		return
	end
	if xSpawn.Distance() > 400 then
		print(xSpawn.Name() .. ' is too far away ' .. xSpawn.Distance())
		return
	end
	local target_id = xSpawn.ID()
	if IsElemental(xSpawn) then
		print(xSpawn.Name() .. ' IsElemental ')
	end
	if mq.TLO.Me.Standing() == false then
		mq.cmd('/stand')
		mq.delay(200)
	end
	print('Target: ' .. mq.TLO.Target.Name())
	mq.cmd('/face fast')
	mq.delay(200)
	if allow_pets then
		mq.cmd('/pet attack')
		mq.delay(100)
		mq.cmd('/pet swarm')
		mq.delay(100)
	end
	if auto_attack then
		print('Attacking ' .. mq.TLO.Target.Name())
		mq.cmd('/attack on')
		mq.delay(100)
	end
	if allow_pets then
		if (mq.TLO.Me.PctMana() > 50) then
			-- BuffMyPet()
			BuffMyPetAA()
			CompanionAegis()
		end
	end
	if flip_mob then
		print('Companion Relocation')
		CastAAWait(COMPANION_RELOCATION, 5000)
		mq.delay(100)
	end
	-- if (mq.TLO.Me.PctMana() > 50) then
	-- 	BuffMyGroup()
	-- end
	-- Malo AA
	if (not xSpawn.Maloed()) then
		WaitCastAA(1041, 5000)
		-- CastAAIfReady(1041, 5000)
	end
	if allow_pets then
		-- Servant of Ro
		CastAAIfReady(174)
		mq.delay(100)
		-- Host of Elements
		CastAAIfReady(207)
		mq.delay(100)
		-- Click Robe
		ClickItem(robe_name)
	end
	DebuffTarget()
	local gem_slot = 0
	DoAutoInv()
	ClickItem(charm_name)
	mq.delay(100)
	if auto_attack then
		print('Attacking ' .. mq.TLO.Target.Name())
		mq.cmd('/attack on')
		mq.delay(100)
	end
	if auto_attack and auto_approach then
		if mq.TLO.Target.Distance() < auto_approach_dist then
			print('sticking ' .. mq.TLO.Target.Name())
			mq.cmd('/stick 10')
		end
		-- mq.cmd('/face fast')
		-- mq.delay(200)
		-- if mq.TLO.Target.Distance() > auto_approach_dist then
		-- 	print('Too far for auto_approach: ' .. mq.TLO.Target.Name() .. ' ' .. mq.TLO.Target.Distance())
		-- else
		-- 	PauseForCasting(5000)
		-- 	MeApproachSpawn(mq.TLO.Target, 10)
		-- end
	end
	while (xSpawn ~= nil) do
		if (mq.TLO.Me.Dead()) then return false end
		if (xSpawn.Dead()) then break end
		if (xSpawn.PctHPs() == nil) then break end
		if (not IsTargetValid()) then break end
		if (mq.TLO.Target.ID() ~= target_id) then break end
		if auto_attack and auto_attack_attempts < 3 then
			mq.cmd('/attack on')
			auto_attack_attempts = auto_attack_attempts + 1
		end
		FeatherHorn()
		if (mq.TLO.Me.PctMana() > 5) then
			DebuffTarget()
			if IsElemental(xSpawn) then
				CastAAIfReady(TURN_SUMMONED)
			end
			for aa in values(battle_aa)  do
				if CastAAIfReady(aa) then break end
			end
			if allow_pets then
				-- Ecliptic Companion
				if (use_ecliptic and mq.TLO.Me.PctMana() > 50) then
					CastSpellIfReady(8)
				end
				-- CompanionAegis()
				if (mq.TLO.Me.PctMana() < 70 and mq.TLO.Me.Pet.PctHPs() > 90) then
					-- Elemental Conversion
					CastAAIfReady(2065)
				end
				ClickItem(amulet_of_mariner)
			end
			-- CastSpellIfReady(6)
			for gem_slot=1,5 do
				if gem_slot > 1 or allow_pets then
					if CastSpellIfReady(gem_slot) then break end
				end
			end
			if (mq.TLO.Me.PctMana() < 70 and mq.TLO.Me.PctHPs() > 99) then
				mq.delay(100)
				ClickFindItem(modrod_name)
				mq.delay(500)
			end
			if (mq.TLO.Me.PctMana() < 70 and mq.TLO.Me.PctHPs() > 99) then
				ClickFindItem(modshard_name)
				mq.delay(500)
			end
			if (mq.TLO.Me.PctMana() < 10) then
				ClickItem(orb_name)
				mq.delay(100)
			end
			if (mq.TLO.Me.PctMana() < 10) then
				ClickItem(paradox_name)
				mq.delay(100)
			end
			if (mq.TLO.Me.PctMana() < 6) then
				if GemReady('Gather Vigor Rk. II') then
					WaitCastSpell('Gather Vigor Rk. II', 15000)
					PauseForCasting(20000)
				end
			end
			if (mq.TLO.Me.PctHPs() < 50) then
				-- Shield of the Elements
				CastAAWait(603, 5000)
				mq.delay(100)
				-- Heart of Froststone
				CastAAWait(786, 5000)
				mq.delay(100)
				if allow_pets then
					-- Companion's Shielding
					CastAAWait(265, 5000)
					mq.delay(100)
				end
			end
			mq.delay(100)
		end
		if allow_pets then
			if (mq.TLO.Me.Pet.PctHPs() < 50) then
				-- Mend Companion
				CastAAWait(58, 5000)
				mq.delay(500)
			end
			if raid == false then
				if (mq.TLO.Me.Pet.PctHPs() < 50) then
					WaitCastSpell(pet_heal_spell, 15000)
					PauseForCasting(10000)
				end
			end
		end
	end
	-- Post Combat Actions
	mq.delay(1000)
	print('GetXtarHaterCount:' .. GetXtarHaterCount())
	print('GetNPCAggroCount:' .. GetNPCAggroCount())
	if GetXtarHaterCount() == 0 then
		PickInvis()
		BuffMyPet()
		SummonModRods()
		SummonOrbs()
		SummonParadox()
		SummonModShard()
		if (mq.TLO.Me.PctMana() < 70) then
			if GemReady('Gather Vigor Rk. II') then
				WaitCastSpell('Gather Vigor Rk. II', 15000)
				PauseForCasting(20000)
			end
		end
		ThaumaturgesUnity()
		if auto_mount then
			MountIfPossible()			
		end
		if MeInvis() then
			print('You are already invis.')
		else
			PickInvis()
		end
		if auto_sit and IsNull(mq.TLO.Me.Mount) then
			PauseForCasting(20000)
			print('No Mount, so sit down.')
			mq.cmd.sit()
		end
	end
	DoAutoInv()
	mq.cmd('/keypress HOME')
end

function PickInvis()
	if invis_after_fight then
		if invis_vs_undead then
			-- Group Invis vs Undead
			WaitCastAA(280, 10000)
		else
			-- Group Invis
			WaitCastAA(1210, 10000)
		end
		mq.delay(100)
	end
end



function BuffMyGroup()
	local target_id = mq.TLO.Target.ID()
	local wanted_buffs = {'Emberweave Coat'}
	if mq.TLO.GroupLeaderName then
		print('Group Size: ' .. mq.TLO.Group.GroupSize())
		for i = 1, mq.TLO.Group.GroupSize() do
			local member = mq.TLO.Group.Member(i)
			member.DoTarget()
			for buffname in values(wanted_buffs) do
				BuffIfMissing(member, buffname)
			end
		end
	else
		local member = mq.TLO.Me
		member.DoTarget()
		for buffname in values(wanted_buffs) do
			BuffIfMissing(member, buffname)
		end
	end
	RetargetId(target_id)
end



function HealerMercReact()
	local mercState = mq.TLO.Me.Mercenary()
	-- print(mercState)
	if not IsNull(mercState) then
		if mercState == 'ACTIVE' then
			local stance = mq.TLO.Me.MercenaryStance()
			-- print(stance)
			if stance == 'Passive' then
				print('Mercenary set to reactive')
				mq.cmd('/stance reactive')
				mq.delay(100)
			end
		end
	end
end


function DebuffTarget()
	if not debuff_target then
		return
	end
	if not mq.TLO.Target.Name() then
		print('No target selected.')
		return
	end
	local xSpawn = mq.TLO.Target
	if xSpawn.Type() ~= 'NPC' then
		print(xSpawn.Name() .. ' is not NPC.')
		return
	end
	if HasBeneficialBuffs(xSpawn) then
		print(xSpawn.Name() .. ' HasBeneficialBuffs')
		-- Eradicate Magic
		CastAAWait(547, 5000)
		mq.delay(100)
	end
end


function FeatherHorn()
	if (mq.TLO.Target.PctHPs() < feather_target_min_hp) then
		return false
	end
	if (mq.TLO.Me.PctMana() > feather_target_max_my_mana) then
		return false
	end
	local feather_duration = SafeInt(mq.TLO.Me.Song(feather_spell).Duration())
	if feather_duration > 0 then
		-- print(feather_spell .. ' duration ' .. feather_spell)
		return false
	end
	local horn_duration = SafeInt(mq.TLO.Me.Song(horn_spell).Duration())
	if horn_duration > 0 then
		-- print(horn_spell .. ' duration ' .. horn_duration)
		return false
	end
	if ClickItem(feather_item) then
		print('CLICKED ' .. feather_item)
		-- mq.cmd('/g ' .. feather_item)
		return true
	end
	if ClickItem(horn_item) then
		print('CLICKED ' .. horn_item)
		-- mq.cmd('/g ' .. horn_item)
		return true
	end
	return false
end


MageKill_2()