---@type Mq
mq = require('mq')

function GetXtarHaterCount()
	return SafeInt(mq.TLO.SpawnCount('xtarhater')())
end

function GetSpawnCount()
	return SafeInt(mq.TLO.SpawnCount('')())
end

function MobsWithinRange(range)
	-- local xSpawn = mq.TLO.NearestSpawn('npc targetable los')
	local xSpawn = mq.TLO.NearestSpawn('npc targetable')
	while (xSpawn.Name()) do
		-- if xSpawn.Targetable() and xSpawn.LineOfSight() and xSpawn.Type() == 'NPC' and not xSpawn.Dead() then
		if xSpawn.Targetable() and xSpawn.Type() == 'NPC' and not xSpawn.Dead() then
			if xSpawn.Distance3D() < range then
				print(xSpawn.Name() .. ' ' .. xSpawn.Race() .. ' ' .. xSpawn.Distance3D())
				xSpawn.DoTarget()
				mq.delay(100)
				mq.cmd('/pet qattack')
			end
		end
		xSpawn = xSpawn.Next
	end
end


function IsElemental(xSpawn)
	if xSpawn.IsSummoned() or xSpawn.Body()== 'Construct' then
		return true
	else
		return false
	end
end

function GetNPCAggroCount()
	local retval = 0
	for i=1,mq.TLO.SpawnCount('npc targetable')() do
		local xSpawn = mq.TLO.NearestSpawn(i .. ', npc targetable')
		if xSpawn.Aggressive() then
			retval = retval + 1
		end
	end
	return retval
end


function ListMobs(substring)
	for i=1,mq.TLO.SpawnCount('npc targetable')() do
		local xSpawn = mq.TLO.NearestSpawn(i .. ', npc targetable')
		if Match_First_i(xSpawn.Name(), substring) then
			print(xSpawn.Name() .. ' (' .. xSpawn.Race() .. ') ' .. xSpawn.Distance3D() .. ' ' .. xSpawn.X() .. ', ' .. xSpawn.Y())
		end
	end
end

function SaveBuffs()
    local buff_count = 0
    for i=1,mq.TLO.Me.MaxBuffSlots() do
        local buffname = mq.TLO.Me.Buff(i).Name()
        if buffname ~= nil then
            local duration = BuffSeconds(mq.TLO.Me, buffname)
            local line = 'Slot ' .. i .. ': ' .. buffname  .. ' (Duration: ' .. duration .. ')'
			print(line)
			LogAppend(line)
            buff_count = buff_count + 1
            if buff_count >= mq.TLO.Me.BuffCount() then
                break
            end
        end
    end
end

function ListRace(substring)
	local xSpawn = mq.TLO.NearestSpawn('npc targetable')
	while (xSpawn.Name()) do
		if Match_First_i(xSpawn.Race(), substring) then
			if xSpawn.Targetable() and xSpawn.Type() == 'NPC' then
				print(xSpawn.Name() .. ' ' .. xSpawn.Race() .. ' ' .. xSpawn.Distance3D())
			end			
		end
		xSpawn = xSpawn.Next
	end
end


function RetargetId(id)
	if id == 0 then
		mq.cmd('/tar clear')
	else
		mq.cmdf('/target id %d', id)
	end
	mq.delay(100)
	if mq.TLO.Target then
		return mq.TLO.Target.ID() == id
	else
		return false
	end
end


function PetQattackXtarhate()
	local haters = GetXtarHaterCount()
	local i = 0
	while (i < haters) do
		i = i + 1
		mq.cmdf('/xtar %d', i)
		mq.delay(100)
		mq.cmd('/pet qattack')
	end
	if haters > 1 then
		mq.cmd('/xtar 1')
	end
	print('qattack ' .. haters)
end

function CastSlotWait(slot, ms)
	print('Casting ' .. mq.TLO.Me.Gem(slot).Name())
	mq.cmdf('/cast %s', slot)
	PauseForCasting(ms)
end

function CastNameWait(spellname, ms)
	print('Casting ' .. spellname)
	mq.cmdf('/cast "%s"', spellname)
	PauseForCasting(ms)
end

function CastAAWait(index, ms)
	if (AAReadyToCast(index)) then
		local myAA = mq.TLO.Me.AltAbility(index)
		print('CastAAWait '.. myAA.Name())
		mq.cmdf('/alt activate "%s"', index)
		PauseForCasting(ms)
	end
end

function values(t)
	local i = 0
	return function() i = i + 1; return t[i] end
end


function BuffSeconds(myspawn, buffname)
	local duration = SafeInt(myspawn.BuffDuration(buffname).TotalSeconds())
	return duration
end


function MyBuffSeconds(buffname)
	local duration = SafeInt(mq.TLO.Me.Buff(buffname).Duration)
	return duration
end


function MySongDuration(songname)
	local duration = SafeInt(mq.TLO.Me.Song(songname).Duration)
	return duration
end


function MeNotCasting()
	return (not mq.TLO.Me.Casting())
end


function BuffIfMissing(xSpawn, buffname)
	local duration = xSpawn.Buff(buffname).Duration()
	local seconds = 0
	if duration then
		seconds = duration
	end
	print(buffname .. ' seconds ' .. seconds)
	if seconds < 20 then
		print(buffname .. ' on ' .. mq.TLO.Me.Name())
		WaitForGemReady(buffname, 10000)
		CastNameWait(buffname, 10000)
	end
end

function IsNull(data)
	if type(data) == 'userdata' then
		if data() == nil then
			return true
		end
	end
	return false
end

function CursorEmpty()
	return IsNull(mq.TLO.Cursor)
end

function CursorNotEmpty()
	return (mq.TLO.Cursor.ID() ~= 0)
end

function PauseForCursor(ms)
	local total_ms = 0
	mq.delay(100)
	while CursorEmpty() do
		mq.delay(100)
		total_ms = total_ms + 100
		if total_ms > ms then
			print('PauseForCursor LIMIT EXCEED: ', ms, total_ms)
			break
		end
	end
	if total_ms > 0 then
		print('PauseForCursor: ' .. total_ms)
	end
end

function GetItem(name)
	local myitem = mq.TLO.FindItem("=" .. name)
	if IsNull(myitem) then
		return nil
	end
	if (myitem) then
		return myitem
	end
	return nil
end

function ClickFindItem(name)
	local myitem = mq.TLO.FindItem(name)
	if (myitem) then
		if (myitem.TimerReady() == 0) then
			print('ClickItem: ' .. name)
			mq.cmdf('/itemnotify "%s" rightmouseup', myitem.Name())
			mq.delay(100)
			PauseForCasting(5000)
		end
	-- else
	-- 	print(name .. ' not found')
	end
end


function MeInvis()
	return mq.TLO.Me.Invis(0)()
end


function ClickItem(name)
	local myitem = GetItem(name)
	if mq.TLO.Me.Casting() or mq.TLO.Me.SpellInCooldown() then
        return false
    end
	if (myitem) then
		-- print(name .. ' timer ' .. myitem.TimerReady())
		if (myitem.TimerReady() == 0) then
			print('ClickItem: ' .. name)
			mq.cmdf('/itemnotify "%s" rightmouseup', myitem.Name())
			mq.delay(500)
			return true
		end
	-- else
	-- 	print(name .. ' not found')
	end
	return false
end

function PauseForCasting(ms)
	local total_ms = 0
	mq.delay(100)
	while (mq.TLO.Me.Casting() or mq.TLO.Me.SpellInCooldown()) do
		mq.delay(100)
		total_ms = total_ms + 100
		if total_ms > ms then
			print('PauseForCasting LIMIT EXCEED: ', ms, total_ms)
			break
		end
	end
	if total_ms > 0 then
		print('PauseForCasting: ' .. total_ms)
	end
	mq.delay(1500)
end

function SafeInt(source)
	if source then
		return source
	end
	return 0
end

function SafeStr(source)
	if source then
		return source
	end
	return ''
end

function Match_First_i(source, pattern)
	if string and pattern then
		return string.match(string.lower(source), string.lower(pattern))
	end
	return nil
end

function Match_First(source, pattern)
	if string and pattern then
		return string.match(source, pattern)
	end
	return nil
end

function GemReady(slot)
	return mq.TLO.Me.SpellReady(slot)()
	-- local duration = SafeInt(mq.TLO.Me.GemTimer(slot-1)())
	-- return (duration == 0)
end

function MemSpell(slot, name)
	local spell = mq.TLO.Me.Gem(name)
	if not IsNull(spell) then
		print('MemSpellWait already memed: ', name)
		return false
	end
	mq.cmdf('/memspell %d "%s"', slot, name)
	return true
end

function MemSpellWait(slot, name, ms)
	if MemSpell(slot, name) then
		local total_ms = 0
		local wait = 200
		while true do
			mq.delay(wait)
			total_ms = total_ms + wait
			-- print(mq.TLO.Window('SpellBookWnd').Open(), mq.TLO.Me.SpellInCooldown(), GemReady(slot))
			if mq.TLO.Window('SpellBookWnd').Open() == false and mq.TLO.Me.SpellInCooldown() == false and GemReady(slot) == true then
				break
			end
			if total_ms > ms then
				print('MemSpellWait LIMIT EXCEED: ', ms, total_ms)
				break
			end
		end
		print('MemSpellWait: ', total_ms)
	end
end

function GemReady1()
    GemReady(1)
end

function GemReady2()
    GemReady(2)
end

function GemReady3()
    GemReady(3)
end

function GemReady4()
    GemReady(4)
end

function GemReady5()
    GemReady(5)
end

function GemReady6()
    GemReady(6)
end

function GemReady7()
    GemReady(7)
end

function GemReady8()
    GemReady(8)
end

function GemReady9()
    GemReady(9)
end

function GemReady10()
    GemReady(10)
end

function GemReady11()
    GemReady(11)
end

function GemReady12()
    GemReady(12)
end

function GemReady13()
    GemReady(13)
end

function WaitForGemReady(spellname, ms)
	local slot = mq.TLO.Me.Gem(spellname)
	if IsNull(slot) then
		print('WaitForGemReady spell not found ' .. spellname)
	end
	WaitForGemReadySlot(spellname, ms)
end

function boolstr(value)
	if value then
		return 'true'
	end
	return 'false'
end

function WaitForGemReadySlot(slot, ms)
	local total_ms = 0
	-- print('WaitForGemReadySlot: ' .. slot)
	while (GemReady(slot) == false or mq.TLO.Me.Casting() == true) do
		mq.delay(100)
		total_ms = total_ms + 100
	end
	if total_ms > 0 then
		print('WaitForGemReadySlot: ' .. slot .. ' Waited: ' .. total_ms)
	end
end


function HasBeneficialBuffs(xSpawn)
	if IsNull(xSpawn) then
		return false
	end
	if xSpawn.BuffsPopulated() then
		for i = 1, xSpawn.BuffCount() do
			if xSpawn.Buff(i).Beneficial() then
				return true
			end
		end
	end
	return false
end

function IsTargetValid()
	return IsTargetValidType('NPC')
end

function IsTargetValidType(target_type)
	if IsNull(mq.TLO.Target) then
		return false
	end
	if not mq.TLO.Target.Name() then
		print('No target selected.')
		return false
	end
	if mq.TLO.Target.Type() ~= target_type then
		print(mq.TLO.Target.Name() .. ' is not ' .. target_type)
		return false
	end
	return true
end

function LogAppend(line)
    local file = io.open("C:\\Games\\MQLog\\mqlog.txt", "a")
	if (file) then
		file:write('[', GetTimeStamp(), '] ', line, "\n")
		file:close()
	end
end

function GetTimeStamp()
	return os.date("%Y-%m-%d_%H:%M:%S")
end

function LogXp()
	local line = mq.TLO.Me.Name() .. ' xp is ' .. string.format("%.3f", mq.TLO.Me.PctExp()) .. '% lvl ' .. mq.TLO.Me.Level()
	print(line)
	LogAppend(line)
end

function DoAutoInv()
	if IsNull(mq.TLO.Cursor.ID()) then
		return
	end
	while mq.TLO.Cursor.ID() do
		mq.cmd.autoinv()
		mq.delay(100)
	end
end

function MountIfPossible()
	if not mq.TLO.Me.CanMount() then
		print('Zone does not allow mounts.')
		return
	end
	if not IsNull(mq.TLO.Me.Mount) then
		print('You are already mounted.')
		return
	end
	print('Summoning mount.')
	mq.cmd('/useitem ${Mount[2]}')
	PauseForCasting(5000)
end

function WaitGemEmpty(slot, ms)
	local wait = 100
	local total_ms = 0
	while GemEmpty(slot) do
        mq.delay(wait)
        total_ms = total_ms + wait
        if total_ms > ms then
            print('WaitGemEmpty LIMIT EXCEED: ', ms)
            return false
        end
    end
	return true
end

function GemEmpty(slot)
    return IsNull(mq.TLO.Me.Gem(slot))
end

function AAEmpty(index)
    return IsNull(mq.TLO.Me.AltAbility(index))
end

function SpellReadyToCast(slot)
    if GemEmpty(slot) then
        return false
    end
    if mq.TLO.Me.SpellInCooldown() then
        return false
    end
    if mq.TLO.Me.Casting() then
        return false
    end
    if not mq.TLO.Me.SpellReady(slot) then
        return false
    end
    local ticks = mq.TLO.Me.GemTimer(slot)()
    return (ticks == 0)
end

function AAReadyToCast(index)
    if AAEmpty(index) then
        return false
    end
    if mq.TLO.Me.SpellInCooldown() then
        return false
    end
    if mq.TLO.Me.Casting() then
        return false
    end
    if not mq.TLO.Me.AltAbilityReady(index) then
        return false
    end
    local ticks = mq.TLO.Me.AltAbilityTimer(index)()
    return (ticks == 0)
end

function Ternary(value, str_true, str_false)
	if value then
		return str_true
	end
	return str_false
end

function WaitCastSpell(slot, ms)
    local wait = 50
	local slot_name = ''
    if GemEmpty(slot) then
        -- No spell in gem
        return false
    end
    local total_ms = 0
    while not SpellReadyToCast(slot) do
        mq.delay(wait)
        total_ms = total_ms + wait
        if total_ms > ms then
            print('WaitCastSpell LIMIT EXCEED: ', ms)
            return false
        end
    end
	if type(slot) == "number" then
		slot_name = mq.TLO.Me.Gem(slot).Name()
	else
		slot_name = slot
	end
    print('Wait ' .. total_ms .. ' Casting ' .. slot_name)
    mq.cmdf('/cast %s', slot)
    mq.delay(500)
    return true
end

function WaitCastAA(index, ms)
    local wait = 50
    if AAEmpty(index) then
        return false
    end
    local total_ms = 0
    while not AAReadyToCast(index) do
        mq.delay(wait)
        total_ms = total_ms + wait
        if total_ms > ms then
            print('WaitCastAA LIMIT EXCEED: ', ms)
            return false
        end
    end
    print('Wait ' .. total_ms .. ' AA ' .. mq.TLO.Me.AltAbility(index).Name())
    mq.cmdf('/alt activate "%s"', index)
    mq.delay(wait*10)
    return true
end

function CastAAIfReady(index)
	if AAReadyToCast(index) then
		WaitCastAA(index, 20000)
		return true
	end
	return false
end

function CastSpellIfReady(slot)
	if SpellReadyToCast(slot) then
		WaitCastSpell(slot, 20000)
		return true
	end
	return false
end

function MeApproachSpawn(xspawn, distance)
	if xspawn.Distance() <= distance then
		print('Approach distance ' .. xspawn.Distance())
		return
	end
	if mq.TLO.Me.Standing() == false then
		print('Stand')
		mq.TLO.Me.Stand()
		mq.delay(100)
	end
	if mq.TLO.Me.Running() == false then
		print('Set to Run')
		mq.cmd('/run')
		mq.delay(100)
	end
	if mq.TLO.Navigation.MeshLoaded() then
		print('Naving ' .. xspawn.Name())
		xspawn.DoTarget()
		mq.delay(100)
		if mq.TLO.Navigation.PathExists('target') then
			mq.cmd('/nav target')
			local total_ms = 0
			while mq.TLO.Navigation.Active() do
				mq.delay(100)
				total_ms = total_ms + 100
				if total_ms > 5000 then
					break
				end
			end
			print('Nav Time: ' .. total_ms)
		end
	else
		print('Approaching ' .. xspawn.Name())
		xspawn.DoTarget()
		mq.delay(100)
		while xspawn.Distance() > distance do
			mq.cmd('/face fast')
			mq.delay(500)
			mq.cmd('/keypress up hold')
			mq.delay(300)
			mq.cmd('/keypress up')
			mq.delay(100)
		end
		-- mq.cmd('/keypress up')
		-- mq.delay(100)
	end
	mq.delay(100)
	mq.cmd('/face fast')
	mq.delay(1000)
	print('Approach distance ' .. xspawn.Distance())
end